import 'package:html/dom.dart';

final RegExp _sym = new RegExp(r'Symbol\("([^"]+)"\)');

class ResponseDom {
  final Document document;
  DomIdQuerier _$;
  DomIdQuerier get $ => _$;

  ResponseDom(this.document) {
    _$ = new DomIdQuerier(document);
  }

  List<Element> $$(String selector) => document.querySelectorAll(selector);
}

class DomIdQuerier {
  final Document document;

  DomIdQuerier(this.document);

  Element operator [](String id) => document.getElementById(id);

  @override
  noSuchMethod(Invocation invocation) {
    if (invocation.isGetter) {
      final id = invocation.memberName.toString().replaceAll(_sym, '');
      return document.getElementById(id);
    }
  }
}
